fprintf('*********** RAY TRACER ************\n')

velname=modelchooser;
[dz,dx,oz,ox,nz,nx,z0,x0,theta,tf,ang1,ang2,nangle]=param;

t0=0.0;
xi(1)=z0;
xi(2)=x0;

[v0,vz0,vx0]=feval(velname,xi(1),xi(2));

hold off
clf
zc=oz*ones(nz,1)+dz*(0:nz-1)';
xc=ox*ones(nx,1)+dx*(0:nx-1)';
zz=zc*ones(1,nx);
xx=ones(nz,1)*xc';
[v,vz,vx]=feval(velname,zz,xx);
imagesc(xc,zc,v);
h=xlabel('x');
set(h,'FontSize',14);
h=ylabel('z');
set(h,'FontSize',14);
colormap('bone');
colorbar;
hold on

dangle = (ang2-ang1)/nangle;

nout=0;
tout=zeros(2,1);
xout=zeros(1,2);
for i=1:nangle
  angle=ang1+dangle*(i-1);
  fprintf('takeoff angle %g of %g = %g\n',i,nangle+1,angle)
  xi(3) = sin(angle)/v0;
  xi(4) = cos(angle)/v0;
%  [t,x] = ode23('rayham',[t0 tf],xi);
%  [t,x] = ode45('rayham',[t0 tf],xi);
  [t,x] = ode113('rayham',[t0 tf],xi,[],velname);
  [nt,junk]=size(t);
  xout(nout+1:nout+nt,2)=x(:,2);
  xout(nout+1:nout+nt,1)=x(:,1);
  tout(nout+1:nout+nt,1)=t;
  nout=nout+nt;
  plot(x(:,2),x(:,1),'r-');
end
hold off
pause

fprintf('interpolating...');
xr=ox:dx:(ox+(nx-1)*dx);
zr=(oz:dz:(oz+(nz-1)*dz))';
tr=zeros(nx,nz);

tr=griddata(xout(:,2),xout(:,1),tout,xr,zr);
colormap('hsv');
imagesc(xr,zr,tr,[0 2.5]);
h=xlabel('x');
set(h,'FontSize',14);
h=ylabel('z');
set(h,'FontSize',14);
colorbar;











