function [rs,me]=tomocg

fprintf('***Least squares tomography by conjugate gradient iteration***\n');

fprintf('create data...\n');
[t,me]=tomodata;

% get geometry of crosswell experiment
[zs,zg,dz,dx,nz,nx]=tomoparam;

% check that data vector t is compatible with geometry
[nr,junk]=size(t);
[junk,ns]=size(zs);
[junk,ng]=size(zg);
if nr ~= ns*ng 
  error('Error: tomodir - size of data wrong')
end

% initialize output slowness array
rs=zeros(nz,nx);

fprintf('construct ray pathlength matrix...\n');
m=plmat(zs,zg,dz,dx,nz,nx);

% set up call to cgls
nc=nz*nx;
x0=zeros(nc,1);
[epsr,nits,tol]=cgpars;

fprintf('solve!\n');
% cgls produces solution as column vec also estimates of
% singular values (lam) and right singular vectors (xi)
[rsvec,lam,xi]=cgls(m,x0,t,epsr,nits,tol);

% reshape for output
rs=reshape(rsvec,nz,nx);




