function [rs,resm,me]=tomodir


fprintf('***Least squares tomography by pseudoinverse***\n');

% solve straight ray tomography problem using
% built-in pseudoinverse

% t     = data (traveltime perturbation)
% rs    = reconstructed slowness perturbation
% resm  = model resolution matrix
% me    = exact (target) model

fprintf('create data...\n');
[t,me]=tomodata;

% grab parameters
[zs,zg,dz,dx,nz,nx,nl]=tomoparam;
[nr,junk]=size(t);
[junk,ns]=size(zs);
[junk,ng]=size(zg);

% since matlab not yet OO, must pass dims in two
% different places - check for consistency
if nr ~= ns*ng 
  error('Error: tomodir - size of data wrong')
end

% initialize solution
rs=zeros(nz,nx);

fprintf('construct ray pathlength matrix...\n');
m=plmat(zs,zg,dz,dx,nz,nx);

fprintf('solve!\n');
% construct pseudoinverse
p=pinv(m);

% build solution vector as column
rsvec=p*t;

% reshape solution for output
rs=reshape(rsvec,nz,nx);

% build model resolution
resm=p*m;

